'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var PublicKey = require('./PublicKey.cjs');
var SdkError = require('./errors/SdkError.cjs');

const getProgramAddressWithFallback = (context, name, address) => {
  const key = PublicKey.publicKey(address);
  if (!context.programs) return key;
  try {
    return context.programs.get(name).address;
  } catch (error) {
    return key;
  }
};
class NullProgramRepository {
  get() {
    throw new SdkError.InterfaceImplementationMissingError('ProgramRepositoryInterface', 'programs');
  }
  all() {
    throw new SdkError.InterfaceImplementationMissingError('ProgramRepositoryInterface', 'programs');
  }
  add() {
    throw new SdkError.InterfaceImplementationMissingError('ProgramRepositoryInterface', 'programs');
  }
  resolveError() {
    throw new SdkError.InterfaceImplementationMissingError('ProgramRepositoryInterface', 'programs');
  }
}

exports.NullProgramRepository = NullProgramRepository;
exports.getProgramAddressWithFallback = getProgramAddressWithFallback;
//# sourceMappingURL=ProgramRepositoryInterface.cjs.map
